#!/bin/sh

# iostat-bf.sh 

# $Id: iostat-bf.sh,v 1.7 2001/02/02 21:09:44 scott Exp $

MET=iostat
NETSTAT=/bin/iostat
OUT=/tmp/iostat.$$

if [ $BBOSTYPE != "solaris" ]
then
  echo
  echo "iostat has only been tested on Solaris > 2.6 "
  echo
  exit 1
fi

#################
# COLLECT
#################
 
# first stab at dealing with getting disk io
# metrics from solaris 2.6 iostat

KEY=/tmp/key.$$
NEWKEY=/tmp/newkey.$$
LOG=/tmp/iostat.out.$$
LOG2=/tmp/iostat.out2.$$
DISKS=/tmp/disks.$$
FINAL=/tmp/iostat.final.$$

# create a key of what filesystems we care about
# the ufs greps
/usr/sbin/mount -p | $GREP " ufs " | $GREP -v " ro" | awk '{print $1,$3}' > $KEY

# now let's create a list of the goods
if [ -f $DISKS ]
then
        rm $DISKS
fi

if [ -f $NEWKEY ]
then
        rm $NEWKEY
fi


cat $KEY | {
while read line
do
        set $line
        BASE=`basename $1`
        echo $BASE >> $DISKS
        echo $BASE $2 >> $NEWKEY
done
}


# go ahead and get the iostat
#iostat -xnpe 300 2 > $LOG
iostat -xnpe 300 2 | $SED 's/ md/ d/' > $LOG

# now get rid of the first half of data
LINES=`cat $LOG | wc -l `
HALF=`expr $LINES / 2`
tail -$HALF $LOG > $LOG2

if [ -f $FINAL ]
then
        rm $FINAL
fi

# now parse the $LOG2 for what we want
for disk in `cat $DISKS`
do
        $GREP " $disk$" $LOG2 >> $FINAL
done

# now lets print what we will send to BB
echo "BEGINKEY" > $OUT
cat $NEWKEY >> $OUT
echo "ENDKEY" >> $OUT

echo "BEGINDATA" >> $OUT
sed -n '2p' $LOG2 >> $OUT
cat $FINAL >> $OUT
echo "ENDDATA" >> $OUT

#################
# REPORT
#################
if [ $LARRDCOMM = DATA ]
then
        $BB $BBDISP "data ${MACHINE}.$MET
`$CAT $OUT`"

else
        $BB $BBDISP "status ${MACHINE}.$MET green `date`  <$MET>
`$CAT $OUT`"

fi

rm $OUT $DISKS $KEY $NEWKEY $FINAL $LOG $LOG2
